"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeBufferToCSV = exports.logPerfEvents = void 0;
const fs = __importStar(require("fs"));
const Context_1 = require("./../p2p/Context");
const CycleCreator_1 = require("../p2p/CycleCreator");
const shardus_1 = require("../shardus");
const csvFilePath = '/nodePerfEvents.csv';
const perfEventBuffer = [];
let numOfEvents = 0;
/* eslint-disable security/detect-non-literal-fs-filename */
function logPerfEvents(eventName) {
    if (Context_1.config.debug.logCSVPerfEvents) {
        if (fs.existsSync(shardus_1.logDir_global + csvFilePath)) {
            const fileSize = fs.statSync(shardus_1.logDir_global + csvFilePath)?.size;
            if (fileSize > 10485760) {
                console.log('perf events csv file size is > 10MB!');
                return;
            }
        }
        else {
            const columns = ['timestamp', 'eventName', 'cycleNumber'];
            appendToCSV(columns);
        }
        const newRow = [Date.now().toString(), eventName, CycleCreator_1.currentCycle.toString()];
        if (numOfEvents < Context_1.config.debug.numOfPerfEventsNeededForLogging) {
            appendToCSV(newRow);
            numOfEvents++;
        }
        else if (numOfEvents % Context_1.config.debug.numOfPerfEventsNeededForLogging === 0) {
            perfEventBuffer.push(newRow);
            for (const event of perfEventBuffer) {
                appendToCSV(event);
            }
            perfEventBuffer.length = 0;
            numOfEvents++;
        }
        else {
            perfEventBuffer.push(newRow);
            numOfEvents++;
        }
    }
}
exports.logPerfEvents = logPerfEvents;
function appendToCSV(data) {
    const csvRow = data.join(',') + '\n';
    fs.appendFileSync(shardus_1.logDir_global + csvFilePath, csvRow, 'utf8');
}
/* eslint-enable security/detect-non-literal-fs-filename */
function writeBufferToCSV() {
    for (const event of perfEventBuffer) {
        appendToCSV(event);
    }
    perfEventBuffer.length = 0;
}
exports.writeBufferToCSV = writeBufferToCSV;
//# sourceMappingURL=csvPerfEvents.js.map