import { P2P } from '@shardeum-foundation/lib-types';
interface ToAcceptResult {
    add: number;
    remove: number;
}
export declare function calculateToAcceptV2(prevRecord: P2P.CycleCreatorTypes.CycleRecord): ToAcceptResult;
/** Returns the number of expired nodes and the list of removed nodes using calculateToAcceptV2 */
export declare function getExpiredRemovedV2(prevRecord: P2P.CycleCreatorTypes.CycleRecord, lastLoggedCycle: number, txs: P2P.RotationTypes.Txs & P2P.ApoptosisTypes.Txs, info: (...msg: string[]) => void): {
    expired: number;
    removed: string[];
};
type GetExpiredRemovedV3Result = {
    problematic: number;
    expired: number;
    removed: string[];
};
/**
 * Gets the list of nodes that should be removed from the network in the next cycle.
 *
*/
export declare function getExpiredRemovedV3(prevRecord: P2P.CycleCreatorTypes.CycleRecord, lastLoggedCycle: number, txs: P2P.RotationTypes.Txs & P2P.ApoptosisTypes.Txs, info: (...msg: string[]) => void): GetExpiredRemovedV3Result;
export {};
