"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initCachedAppData = exports.schemaCachedAppData = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaCachedAppData = {
    type: 'object',
    properties: {
        cycle: { type: 'number' },
        appData: { type: 'object' },
        dataID: { type: 'string' },
    },
    required: ['cycle', 'appData', 'dataID'],
    additionalProperties: false,
};
function initCachedAppData() {
    addSchemaDependencies();
    addSchemas();
}
exports.initCachedAppData = initCachedAppData;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.CachedAppData, exports.schemaCachedAppData);
}
//# sourceMappingURL=CachedAppData.js.map