"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGetAccountDataByHashesReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const schemaAccountIDAndHash = {
    type: 'object',
    properties: {
        accountID: { type: 'string' },
        hash: { type: 'string' },
    },
    required: ['accountID', 'hash'],
};
const schemaGetAccountDataByHashesReq = {
    type: 'object',
    properties: {
        cycle: { type: 'number' },
        accounts: {
            type: 'array',
            items: schemaAccountIDAndHash,
        },
    },
    required: ['cycle', 'accounts'],
};
function initGetAccountDataByHashesReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGetAccountDataByHashesReq = initGetAccountDataByHashesReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)('GetAccountDataByHashesReq', schemaGetAccountDataByHashesReq);
}
//# sourceMappingURL=GetAccountDataByHashesReq.js.map