"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGetAccountQueueCountResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const getAccountQueueCountRespSchema = {
    oneOf: [
        {
            type: 'object',
            properties: {
                counts: {
                    type: 'array',
                    items: { type: 'number' },
                },
                committingAppData: {
                    type: 'array',
                    items: {}, // unknown
                },
                accounts: {
                    type: 'array',
                    items: {}, // unknown
                },
            },
            required: ['counts', 'committingAppData', 'accounts'],
        },
        {
            type: 'boolean',
            enum: [false],
        },
    ],
};
function initGetAccountQueueCountResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGetAccountQueueCountResp = initGetAccountQueueCountResp;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.GetAccountQueueCountResp, getAccountQueueCountRespSchema);
}
//# sourceMappingURL=GetAccountQueueCountResp.js.map