"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGetTrieHashesResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const SchemaGetTrieHashesResp = {
    type: 'object',
    properties: {
        nodeHashes: {
            type: 'array',
            items: {
                type: 'object',
                properties: {
                    radix: { type: 'string' },
                    hash: { type: 'string' },
                },
                required: ['radix', 'hash'],
            },
        },
        nodeId: { type: 'string' },
    },
    required: ['nodeHashes'],
};
function initGetTrieHashesResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGetTrieHashesResp = initGetTrieHashesResp;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.GetTrieHashesResp, SchemaGetTrieHashesResp);
}
//# sourceMappingURL=GetTrieHashesResp.js.map