"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initGlobalAccountReportResp = exports.schemaGlobalAccountReportResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
exports.schemaGlobalAccountReportResp = {
    type: 'object',
    oneOf: [
        {
            type: 'object',
            properties: {
                ready: { type: 'boolean' },
                combinedHash: { type: 'string' },
                accounts: {
                    type: 'array',
                    items: {
                        type: 'object',
                        properties: {
                            id: { type: 'string' },
                            hash: { type: 'string' },
                            timestamp: { type: 'number' },
                        },
                        required: ['id', 'hash', 'timestamp'],
                    },
                },
            },
            required: ['ready', 'combinedHash', 'accounts'],
        },
        {
            type: 'object',
            properties: {
                error: { type: 'string' },
            },
            required: ['error'],
        },
    ],
};
function initGlobalAccountReportResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initGlobalAccountReportResp = initGlobalAccountReportResp;
function addSchemaDependencies() {
    // No dependencies
}
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.GlobalAccountReportResp, exports.schemaGlobalAccountReportResp);
}
//# sourceMappingURL=GlobalAccountReportResp.js.map