"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initMakeReceiptReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const schemaSign = {
    type: 'object',
    properties: {
        owner: { type: 'string' },
        sig: { type: 'string' },
    },
    required: ['owner', 'sig'],
};
const schemaMakeReceiptReq = {
    type: 'object',
    properties: {
        sign: { type: 'object', items: schemaSign },
        address: { type: 'string' },
        value: {},
        when: { type: 'number' },
        source: { type: 'string' },
    },
    required: ['sign', 'address', 'value', 'when', 'source'],
};
function initMakeReceiptReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initMakeReceiptReq = initMakeReceiptReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)('schemaSign', schemaSign);
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.MakeReceiptReq, schemaMakeReceiptReq);
}
//# sourceMappingURL=MakeReceiptReq.js.map