"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initRequestStateForTxPostResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const WrappedDataResponse_1 = require("./WrappedDataResponse");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const schemaRequestStateForTxPostResp = {
    type: 'object',
    properties: {
        stateList: {
            type: 'array',
            items: WrappedDataResponse_1.schemaWrappedDataResponse,
        },
        beforeHashes: {
            type: 'object',
            additionalProperties: { type: 'string' },
        },
        note: { type: 'string' },
        success: { type: 'boolean' },
    },
    required: ['stateList', 'beforeHashes', 'note', 'success'],
};
function initRequestStateForTxPostResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initRequestStateForTxPostResp = initRequestStateForTxPostResp;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.RequestStateForTxPostResp, schemaRequestStateForTxPostResp);
}
//# sourceMappingURL=RequestStateForTxPostResp.js.map