"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initRequestStateForTxResp = exports.schemaRequestStateForTxResp = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const WrappedData_1 = require("./WrappedData");
exports.schemaRequestStateForTxResp = {
    type: 'object',
    properties: {
        stateList: { type: 'array', items: WrappedData_1.schemaWrappedData },
        beforeHashes: {
            type: 'object',
            additionalProperties: {
                type: 'string',
            },
        },
        note: { type: 'string' },
        success: { type: 'boolean' },
    },
    required: ['stateList', 'beforeHashes', 'note', 'success'],
};
function initRequestStateForTxResp() {
    addSchemaDependencies();
    addSchemas();
}
exports.initRequestStateForTxResp = initRequestStateForTxResp;
function addSchemaDependencies() {
    // No dependencies
}
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.RequestStateForTxResp, exports.schemaRequestStateForTxResp);
}
//# sourceMappingURL=RequestStateForTxResp.js.map