"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSpreadAppliedVoteHashReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const schemaSpreadAppliedVoteHashReq = {
    type: 'object',
    properties: {
        txid: { type: 'string' },
        voteHash: { type: 'string' },
        sign: {
            type: 'object',
            properties: {
                owner: { type: 'string' },
                sig: { type: 'string' },
            },
            required: ['owner', 'sig'],
            additionalProperties: false,
        },
    },
    required: ['txid', 'voteHash'],
    additionalProperties: false,
};
function initSpreadAppliedVoteHashReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initSpreadAppliedVoteHashReq = initSpreadAppliedVoteHashReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.SpreadAppliedVoteHashReq, schemaSpreadAppliedVoteHashReq);
}
//# sourceMappingURL=SpreadAppliedVoteHashReq.js.map