"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initSyncTrieHashesReq = void 0;
const SchemaHelpers_1 = require("../../utils/serialization/SchemaHelpers");
const AJVSchemaEnum_1 = require("../enum/AJVSchemaEnum");
const schemaSyncTrieHashesReq = {
    type: 'object',
    properties: {
        cycle: { type: 'number' },
        nodeHashes: {
            type: 'array',
            items: {
                type: 'object',
                properties: {
                    radix: { type: 'string' },
                    hash: { type: 'string' },
                },
                required: ['radix', 'hash'],
            },
        },
    },
    required: ['cycle', 'nodeHashes'],
};
function initSyncTrieHashesReq() {
    addSchemaDependencies();
    addSchemas();
}
exports.initSyncTrieHashesReq = initSyncTrieHashesReq;
// Function to add schema dependencies
function addSchemaDependencies() {
    // No dependencies
}
// Function to register the schema
function addSchemas() {
    (0, SchemaHelpers_1.addSchema)(AJVSchemaEnum_1.AJVSchemaEnum.SyncTrieHashesReq, schemaSyncTrieHashesReq);
}
//# sourceMappingURL=SyncTrieHashesReq.js.map